#include "XAPOBase.h"
#include <assert.h>

XAPOBase::~XAPOBase(void)
{
}
HRESULT XAPOBase::GetRegistrationProperties(XAPO_REGISTRATION_PROPERTIES** ppRegistrationProperties){
	XAPO_REGISTRATION_PROPERTIES* p=(XAPO_REGISTRATION_PROPERTIES*)XAPOAlloc(sizeof(XAPO_REGISTRATION_PROPERTIES));
	*ppRegistrationProperties=p;
	memcpy(p,m_pRegistrationProperties,sizeof(XAPO_REGISTRATION_PROPERTIES));
	return S_OK;
}
HRESULT XAPOBase::IsInputFormatSupported(THIS_ const WAVEFORMATEX* pOutputFormat, const WAVEFORMATEX* pRequestedInputFormat, __deref_opt_out WAVEFORMATEX** ppSupportedInputFormat){
	return S_OK;
}
HRESULT XAPOBase::IsOutputFormatSupported(THIS_ const WAVEFORMATEX* pInputFormat, const WAVEFORMATEX* pRequestedOutputFormat, __deref_opt_out WAVEFORMATEX** ppSupportedOutputFormat){
	return S_OK;
}
HRESULT XAPOBase::Initialize(THIS_ __in_bcount_opt(DataByteSize) const void* pData, UINT32 DataByteSize){
	return S_OK;
}
void XAPOBase::Reset(THIS){
}
HRESULT XAPOBase::LockForProcess(THIS_ UINT32 InputLockedParameterCount, __in_ecount_opt(InputLockedParameterCount) const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS* pInputLockedParameters, UINT32 OutputLockedParameterCount, __in_ecount_opt(OutputLockedParameterCount) const XAPO_LOCKFORPROCESS_BUFFER_PARAMETERS* pOutputLockedParameters){
	return S_OK;
}
void XAPOBase::UnlockForProcess(THIS){
}
UINT32 XAPOBase::CalcInputFrames(THIS_ UINT32 OutputFrameCount){
	return 0;
}
UINT32 XAPOBase::CalcOutputFrames(THIS_ UINT32 InputFrameCount){
	return 0;
}



XAPOParametersBase::XAPOParametersBase(const XAPO_REGISTRATION_PROPERTIES* pRegistrationProperties, BYTE* pParameterBlocks, UINT32 uParameterBlockByteSize, BOOL fProducer)
	:XAPOBase(pRegistrationProperties){
	m_pParameterBlocks=pParameterBlocks;
    m_pCurrentParameters=new BYTE[uParameterBlockByteSize];
    m_pCurrentParametersInternal=new BYTE[uParameterBlockByteSize];
	m_uParameterBlockByteSize=uParameterBlockByteSize;
}
XAPOParametersBase::~XAPOParametersBase (){
	delete[] m_pCurrentParameters;
	delete[] m_pCurrentParametersInternal;
}
BOOL XAPOParametersBase::ParametersChanged (){
	return TRUE;
}
BYTE* XAPOParametersBase::BeginProcess (){
	memcpy(m_pCurrentParameters,m_pParameterBlocks,m_uParameterBlockByteSize);
	return m_pCurrentParameters;
}
void XAPOParametersBase::EndProcess (){
	memcpy(m_pParameterBlocks,m_pCurrentParameters,m_uParameterBlockByteSize);
}

void XAPOParametersBase::SetParameters(__in_bcount(ParameterByteSize) const void* pParameters, UINT32 ParameterByteSize){
	m_pParameterBlocks=(BYTE*)pParameters;
	/*
	memcpy(m_pParameterBlocks,pParameters,ParameterByteSize);
	memcpy(m_pCurrentParameters,pParameters,ParameterByteSize);
	memcpy(m_pCurrentParametersInternal,pParameters,ParameterByteSize);
	*/
}
void XAPOParametersBase::GetParameters(__out_bcount(ParameterByteSize) void* pParameters, UINT32 ParameterByteSize){
	pParameters=m_pParameterBlocks;
}